#include<iostream.h>
#include"theelements.h"
#include"primitives.h"
#ifndef NULL
#define NULL ((void *)0)
#endif

// THIS CLASS DEFINITION IS PART 1 OF A 2-D LINKED LIST
// THIS SECTION DEFINES THE VERTICAL POINTERS BETWEEN THE
// ROWS

class list_broad{
private:
  list_broad *next;
  list_broad *prev;

// DEFINITIONS FOR PART 2 OF LINKED LIST
// WHICH CONTAINS THE dataset INFO. AND THE HORIZONTAL POINTERS
// BETWEEN datasets 
  list3 elements;
  list_values *valptr;

public:
  list_broad():
    next(NULL),
    prev(NULL)
    {
    }

  inline list_broad *get_next()
    {
// RETURNS THE NEXT ROW
      return next;
    }

  inline void set_next(list_broad *n)
    {
// SETS WHAT THE NEXT ROW IS
      next=n;
    }

  list_broad *get_prev()
    {
// IS DOUBLY LINKED. RETURNS PREVIOUS ROW
      return prev;
    }

  inline void addelem(short a,short x, short y)
	{
// ADDS IN dataset INFORMATION (destination-node, element to change, value)
	elements.append(new list_values(a,x,y));
	}

  inline short getforwhichnode()
	{
// RETURN THE VALUE FOR THE DESTINATION NODE/RECEIVER
	return valptr->getforwhichnode();
	}

  inline short getelement()
	{
// RETURNS THE VALUE FOR WHICH ELEMENT IS SET TO CHANGE BY RECEIVER
 //       valptr=elements.first();
	short bob=valptr->getelement();
	return bob; 
	}

  void gotofirst()
	{
// GO TO THE FIRST dataset IN THE ROW
	valptr=elements.first();
	}

  int isnull()
	{
// IS THE ROW DEVOID OF datasets?
//	valptr=elements.first();
	if (valptr==NULL)
		return(1);
	else return(0);
	}

  inline short getvalue()
	{
// RETURNS THE VALUE THE RECEIVER WILL BE USING TO UPDATE
// ITS ROUTING TABLE. ALSO DELETES THE dataset
	valptr=elements.first();
	short tempval=valptr->getvalue();
	elements.remove(valptr);
	delete valptr;
	return tempval;
	}

void  advance()
	{
// ADVANCE TO NEXT dataset IN ROW 
	valptr=elements.next(valptr);
	}

  short returnvalue()
	{
// RETURNS THE VALUE THE RECEIVER WILL BE USING TO UPDATE
// ITS ROUTING TABLE DOES NOT DELETE dataset
//	valptr=elements.first();
	short tempval=valptr->getvalue();
	return tempval;
	}

  void set_prev(list_broad *n)
    {
      prev=n;
    }

  void insert_after(list_broad *n)
    {
      list_broad *after=next;
      n->next=after;
      next=n;
      n->prev=this;
      if (after!=NULL){
	after->prev=n;
      }
    }

  ~list_broad ()
	{
	/*
	cout<<"deleting pointers."<<endl;
	delete next;
	delete prev;
	cout<<"done."<<endl;*/
	}
	
  list_broad* remove1(list_broad *n)
    {
     (n->prev)->set_next(n->next);
     (n->next)->set_prev(n->prev);
     delete n;
     return(NULL);
    } 

};

class list2 {
// class listing for actual object
private:
  list_broad *head, *tail;
public:
  list2() :
    head(NULL),
    tail(NULL)
    {
    }
  list_broad* remove(list_broad *n)
    {
	// function calls to remove an object from the list
      if (head==NULL) 
		{
		delete n;
		return(NULL);}
      else if (n==head)
	{
	 if (n->get_next()==NULL)
		{
		head=NULL;
		delete n;
		return(NULL);
		}
	 else
	{
	 make_head(n->get_next());
	 delete n; 
	 return(NULL);}
	}
      else if (n==tail)
	{
	 if (n->get_prev()==NULL)
		{
		head=NULL;
		tail=NULL;
		return(NULL);
		}
	else
	{
	make_tail(n->get_prev());
	delete n;
	return (NULL);}
	}
      else 
	{
		n->remove1(n);	
	}
    }
  list_broad* next(list_broad *n)
    {
      return n->get_next();
    }
  list_broad* previous(list_broad *n)
	{
	return n->get_prev();
	}
  void prepend(list_broad *n) 
    {
	// insert new element before passed one
      n->insert_after(head);
      n->set_prev(NULL);
      head=n;
    }
  void append(list_broad *n){
	// insert new element after passed one
    if (head==NULL){
      head=tail=n; }
    else {
      insert_after(n,tail);
    }
  }
  void insert_after (list_broad *n, list_broad *p)
    {
      p->insert_after(n);
      if (n->get_next()==NULL){
	tail=n;
      }
    }
  list_broad* first()
    {
      return head;
    }
  list_broad* last()
    {
      return tail;
    }

  void make_head(list_broad *node) {
    head = node;
    node->set_prev(NULL);
  }
  void make_tail(list_broad *node) {
    tail=node;
    node->set_next(NULL);
  }

};
